<?php
// This file was auto-generated from sdk-root/src/data/lambda/2015-03-31/docs-2.json
return [ 'version' => '2.0', 'service' => '<fullname>AWS Lambda</fullname> <p> <b>Overview</b> </p> <p>This is the <i>AWS Lambda API Reference</i>. The AWS Lambda Developer Guide provides additional information. For the service overview, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/welcome.html">What is AWS Lambda</a>, and for information about how the service works, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/lambda-introduction.html">AWS Lambda: How it Works</a> in the <b>AWS Lambda Developer Guide</b>.</p>', 'operations' => [ 'AddLayerVersionPermission' => '<p>Adds permissions to the resource-based policy of a version of a function layer. Use this action to grant layer usage permission to other accounts. You can grant permission to a single account, all AWS accounts, or all accounts in an organization.</p> <p>To revoke permission, call <a>RemoveLayerVersionPermission</a> with the statement ID that you specified when you added it.</p>', 'AddPermission' => '<p>Adds a permission to the resource policy associated with the specified AWS Lambda function. You use resource policies to grant permissions to event sources that use the <i>push</i> model. In a <i>push</i> model, event sources (such as Amazon S3 and custom applications) invoke your Lambda function. Each permission you add to the resource policy allows an event source permission to invoke the Lambda function. </p> <p>Permissions apply to the Amazon Resource Name (ARN) used to invoke the function, which can be unqualified (the unpublished version of the function), or include a version or alias. If a client uses a version or alias to invoke a function, use the <code>Qualifier</code> parameter to apply permissions to that ARN. For more information about versioning, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">AWS Lambda Function Versioning and Aliases</a>. </p> <p>This operation requires permission for the <code>lambda:AddPermission</code> action.</p>', 'CreateAlias' => '<p>Creates an alias that points to the specified Lambda function version. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/aliases-intro.html">Introduction to AWS Lambda Aliases</a>.</p> <p>Alias names are unique for a given function. This requires permission for the lambda:CreateAlias action.</p>', 'CreateEventSourceMapping' => '<p>Creates a mapping between an event source and an AWS Lambda function. Lambda reads items from the event source and triggers the function.</p> <p>For details about each event source type, see the following topics.</p> <ul> <li> <p> <a href="http://docs.aws.amazon.com/lambda/latest/dg/with-kinesis.html">Using AWS Lambda with Amazon Kinesis</a> </p> </li> <li> <p> <a href="http://docs.aws.amazon.com/lambda/latest/dg/with-sqs.html">Using AWS Lambda with Amazon SQS</a> </p> </li> <li> <p> <a href="http://docs.aws.amazon.com/lambda/latest/dg/with-ddb.html">Using AWS Lambda with Amazon DynamoDB</a> </p> </li> </ul>', 'CreateFunction' => '<p>Creates a new Lambda function. The function configuration is created from the request parameters, and the code for the function is provided by a .zip file. The function name is case-sensitive.</p> <p>This operation requires permission for the <code>lambda:CreateFunction</code> action.</p>', 'DeleteAlias' => '<p>Deletes the specified Lambda function alias. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/aliases-intro.html">Introduction to AWS Lambda Aliases</a>.</p> <p>This requires permission for the lambda:DeleteAlias action.</p>', 'DeleteEventSourceMapping' => '<p>Deletes an event source mapping.</p>', 'DeleteFunction' => '<p>Deletes a Lambda function. To delete a specific function version, use the <code>Qualifier</code> parameter. Otherwise, all versions and aliases are deleted. Event source mappings are not deleted.</p> <p>This operation requires permission for the <code>lambda:DeleteFunction</code> action.</p>', 'DeleteFunctionConcurrency' => '<p>Removes concurrent execution limits from this function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/concurrent-executions.html">Managing Concurrency</a>.</p>', 'DeleteLayerVersion' => '<p>Deletes a version of a function layer. Deleted versions can no longer be viewed or added to functions. However, a copy of the version remains in Lambda until no functions refer to it.</p>', 'GetAccountSettings' => '<p>Retrieves details about your account\'s <a href="http://docs.aws.amazon.com/lambda/latest/dg/limits.html">limits</a> and usage in a region.</p>', 'GetAlias' => '<p>Returns the specified alias information such as the alias ARN, description, and function version it is pointing to. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/aliases-intro.html">Introduction to AWS Lambda Aliases</a>.</p> <p>This requires permission for the <code>lambda:GetAlias</code> action.</p>', 'GetEventSourceMapping' => '<p>Returns details about an event source mapping.</p>', 'GetFunction' => '<p>Returns the configuration information of the Lambda function and a presigned URL link to the .zip file you uploaded with <a>CreateFunction</a> so you can download the .zip file. Note that the URL is valid for up to 10 minutes. The configuration information is the same information you provided as parameters when uploading the function.</p> <p>Use the <code>Qualifier</code> parameter to retrieve a published version of the function. Otherwise, returns the unpublished version (<code>$LATEST</code>). For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">AWS Lambda Function Versioning and Aliases</a>.</p> <p>This operation requires permission for the <code>lambda:GetFunction</code> action.</p>', 'GetFunctionConfiguration' => '<p>Returns the configuration information of the Lambda function. This the same information you provided as parameters when uploading the function by using <a>CreateFunction</a>.</p> <p>If you are using the versioning feature, you can retrieve this information for a specific function version by using the optional <code>Qualifier</code> parameter and specifying the function version or alias that points to it. If you don\'t provide it, the API returns information about the $LATEST version of the function. For more information about versioning, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">AWS Lambda Function Versioning and Aliases</a>.</p> <p>This operation requires permission for the <code>lambda:GetFunctionConfiguration</code> operation.</p>', 'GetLayerVersion' => '<p>Returns information about a version of a function layer, with a link to download the layer archive that\'s valid for 10 minutes.</p>', 'GetLayerVersionPolicy' => '<p>Returns the permission policy for a layer version. For more information, see <a>AddLayerVersionPermission</a>.</p>', 'GetPolicy' => '<p>Returns the resource policy associated with the specified Lambda function.</p> <p>This action requires permission for the <code>lambda:GetPolicy action.</code> </p>', 'Invoke' => '<p>Invokes a Lambda function. For an example, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/with-dynamodb-create-function.html#with-dbb-invoke-manually">Create the Lambda Function and Test It Manually</a>. </p> <p>Specify just a function name to invoke the latest version of the function. To invoke a published version, use the <code>Qualifier</code> parameter to specify a <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">version or alias</a>.</p> <p>If you use the <code>RequestResponse</code> (synchronous) invocation option, the function will be invoked only once. If you use the <code>Event</code> (asynchronous) invocation option, the function will be invoked at least once in response to an event and the function must be idempotent to handle this.</p> <p>For functions with a long timeout, your client may be disconnected during synchronous invocation while it waits for a response. Configure your HTTP client, SDK, firewall, proxy, or operating system to allow for long connections with timeout or keep-alive settings.</p> <p>This operation requires permission for the <code>lambda:InvokeFunction</code> action.</p> <p>The <code>TooManyRequestsException</code> noted below will return the following: <code>ConcurrentInvocationLimitExceeded</code> will be returned if you have no functions with reserved concurrency and have exceeded your account concurrent limit or if a function without reserved concurrency exceeds the account\'s unreserved concurrency limit. <code>ReservedFunctionConcurrentInvocationLimitExceeded</code> will be returned when a function with reserved concurrency exceeds its configured concurrency limit. </p>', 'InvokeAsync' => '<important> <p>For asynchronous function invocation, use <a>Invoke</a>.</p> </important> <p>Submits an invocation request to AWS Lambda. Upon receiving the request, Lambda executes the specified function asynchronously. To see the logs generated by the Lambda function execution, see the CloudWatch Logs console.</p> <p>This operation requires permission for the <code>lambda:InvokeFunction</code> action.</p>', 'ListAliases' => '<p>Returns list of aliases created for a Lambda function. For each alias, the response includes information such as the alias ARN, description, alias name, and the function version to which it points. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/aliases-intro.html">Introduction to AWS Lambda Aliases</a>.</p> <p>This requires permission for the lambda:ListAliases action.</p>', 'ListEventSourceMappings' => '<p>Lists event source mappings. Specify an <code>EventSourceArn</code> to only show event source mappings for a single event source.</p>', 'ListFunctions' => '<p>Returns a list of your Lambda functions. For each function, the response includes the function configuration information. You must use <a>GetFunction</a> to retrieve the code for your function.</p> <p>This operation requires permission for the <code>lambda:ListFunctions</code> action.</p> <p>If you are using the versioning feature, you can list all of your functions or only <code>$LATEST</code> versions. For information about the versioning feature, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">AWS Lambda Function Versioning and Aliases</a>. </p>', 'ListLayerVersions' => '<p>Lists the versions of a function layer. Versions that have been deleted aren\'t listed. Specify a <a href="http://docs.aws.amazon.com/lambda/latest/dg/lambda-runtimes.html">runtime identifier</a> to list only versions that indicate that they\'re compatible with that runtime.</p>', 'ListLayers' => '<p>Lists function layers and shows information about the latest version of each. Specify a <a href="http://docs.aws.amazon.com/lambda/latest/dg/lambda-runtimes.html">runtime identifier</a> to list only layers that indicate that they\'re compatible with that runtime.</p>', 'ListTags' => '<p>Returns a list of tags assigned to a function when supplied the function ARN (Amazon Resource Name). For more information on Tagging, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>.</p>', 'ListVersionsByFunction' => '<p>Lists all versions of a function. For information about versioning, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">AWS Lambda Function Versioning and Aliases</a>. </p>', 'PublishLayerVersion' => '<p>Creates a function layer from a ZIP archive. Each time you call <code>PublishLayerVersion</code> with the same version name, a new version is created.</p> <p>Add layers to your function with <a>CreateFunction</a> or <a>UpdateFunctionConfiguration</a>.</p>', 'PublishVersion' => '<p>Publishes a version of your function from the current snapshot of $LATEST. That is, AWS Lambda takes a snapshot of the function code and configuration information from $LATEST and publishes a new version. The code and configuration cannot be modified after publication. For information about the versioning feature, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">AWS Lambda Function Versioning and Aliases</a>. </p>', 'PutFunctionConcurrency' => '<p>Sets a limit on the number of concurrent executions available to this function. It is a subset of your account\'s total concurrent execution limit per region. Note that Lambda automatically reserves a buffer of 100 concurrent executions for functions without any reserved concurrency limit. This means if your account limit is 1000, you have a total of 900 available to allocate to individual functions. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/concurrent-executions.html">Managing Concurrency</a>.</p>', 'RemoveLayerVersionPermission' => '<p>Removes a statement from the permissions policy for a layer version. For more information, see <a>AddLayerVersionPermission</a>.</p>', 'RemovePermission' => '<p>Removes permissions from a function. You can remove individual permissions from an resource policy associated with a Lambda function by providing a statement ID that you provided when you added the permission. When you remove permissions, disable the event source mapping or trigger configuration first to avoid errors.</p> <p>Permissions apply to the Amazon Resource Name (ARN) used to invoke the function, which can be unqualified (the unpublished version of the function), or include a version or alias. If a client uses a version or alias to invoke a function, use the <code>Qualifier</code> parameter to apply permissions to that ARN. For more information about versioning, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">AWS Lambda Function Versioning and Aliases</a>. </p> <p>You need permission for the <code>lambda:RemovePermission</code> action.</p>', 'TagResource' => '<p>Creates a list of tags (key-value pairs) on the Lambda function. Requires the Lambda function ARN (Amazon Resource Name). If a key is specified without a value, Lambda creates a tag with the specified key and a value of null. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>. </p>', 'UntagResource' => '<p>Removes tags from a Lambda function. Requires the function ARN (Amazon Resource Name). For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>. </p>', 'UpdateAlias' => '<p>Using this API you can update the function version to which the alias points and the alias description. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/aliases-intro.html">Introduction to AWS Lambda Aliases</a>.</p> <p>This requires permission for the lambda:UpdateAlias action.</p>', 'UpdateEventSourceMapping' => '<p>Updates an event source mapping. You can change the function that AWS Lambda invokes, or pause invocation and resume later from the same location.</p>', 'UpdateFunctionCode' => '<p>Updates the code for the specified Lambda function. This operation must only be used on an existing Lambda function and cannot be used to update the function configuration.</p> <p>If you are using the versioning feature, note this API will always update the $LATEST version of your Lambda function. For information about the versioning feature, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">AWS Lambda Function Versioning and Aliases</a>. </p> <p>This operation requires permission for the <code>lambda:UpdateFunctionCode</code> action.</p>', 'UpdateFunctionConfiguration' => '<p>Updates the configuration parameters for the specified Lambda function by using the values provided in the request. You provide only the parameters you want to change. This operation must only be used on an existing Lambda function and cannot be used to update the function\'s code.</p> <p>If you are using the versioning feature, note this API will always update the $LATEST version of your Lambda function. For information about the versioning feature, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/versioning-aliases.html">AWS Lambda Function Versioning and Aliases</a>. </p> <p>This operation requires permission for the <code>lambda:UpdateFunctionConfiguration</code> action.</p>', ], 'shapes' => [ 'AccountLimit' => [ 'base' => '<p>Provides limits of code size and concurrency associated with the current account and region. For more information or to request a limit increase for concurrent executions, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/limits.html">Lambda Limits</a>. </p>', 'refs' => [ 'GetAccountSettingsResponse$AccountLimit' => '<p>Limits related to concurrency and code storage.</p>', ], ], 'AccountUsage' => [ 'base' => '<p>Provides code size usage and function count associated with the current account and region.</p>', 'refs' => [ 'GetAccountSettingsResponse$AccountUsage' => '<p>The number of functions and amount of storage in use.</p>', ], ], 'Action' => [ 'base' => NULL, 'refs' => [ 'AddPermissionRequest$Action' => '<p>The AWS Lambda action you want to allow in this statement. Each Lambda action is a string starting with <code>lambda:</code> followed by the API name . For example, <code>lambda:CreateFunction</code>. You can use wildcard (<code>lambda:*</code>) to grant permission for all AWS Lambda actions. </p>', ], ], 'AddLayerVersionPermissionRequest' => [ 'base' => NULL, 'refs' => [], ], 'AddLayerVersionPermissionResponse' => [ 'base' => NULL, 'refs' => [], ], 'AddPermissionRequest' => [ 'base' => NULL, 'refs' => [], ], 'AddPermissionResponse' => [ 'base' => NULL, 'refs' => [], ], 'AdditionalVersion' => [ 'base' => NULL, 'refs' => [ 'AdditionalVersionWeights$key' => NULL, ], ], 'AdditionalVersionWeights' => [ 'base' => NULL, 'refs' => [ 'AliasRoutingConfiguration$AdditionalVersionWeights' => '<p>The name of the second alias, and the percentage of traffic that is routed to it.</p>', ], ], 'Alias' => [ 'base' => NULL, 'refs' => [ 'AliasConfiguration$Name' => '<p>Alias name.</p>', 'CreateAliasRequest$Name' => '<p>Name for the alias you are creating.</p>', 'DeleteAliasRequest$Name' => '<p>Name of the alias to delete.</p>', 'GetAliasRequest$Name' => '<p>Name of the alias for which you want to retrieve information.</p>', 'UpdateAliasRequest$Name' => '<p>The alias name.</p>', ], ], 'AliasConfiguration' => [ 'base' => '<p>Provides configuration information about a Lambda function version alias.</p>', 'refs' => [ 'AliasList$member' => NULL, ], ], 'AliasList' => [ 'base' => NULL, 'refs' => [ 'ListAliasesResponse$Aliases' => '<p>A list of aliases.</p>', ], ], 'AliasRoutingConfiguration' => [ 'base' => '<p>The alias\'s <a href="http://docs.aws.amazon.com/lambda/latest/dg/lambda-traffic-shifting-using-aliases.html">traffic shifting</a> configuration.</p>', 'refs' => [ 'AliasConfiguration$RoutingConfig' => '<p>Specifies an additional function versions the alias points to, allowing you to dictate what percentage of traffic will invoke each version.</p>', 'CreateAliasRequest$RoutingConfig' => '<p>Specifies an additional version your alias can point to, allowing you to dictate what percentage of traffic will invoke each version. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/lambda-traffic-shifting-using-aliases.html">Traffic Shifting Using Aliases</a>.</p>', 'UpdateAliasRequest$RoutingConfig' => '<p>Specifies an additional version your alias can point to, allowing you to dictate what percentage of traffic will invoke each version. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/lambda-traffic-shifting-using-aliases.html">Traffic Shifting Using Aliases</a>.</p>', ], ], 'Arn' => [ 'base' => NULL, 'refs' => [ 'AddPermissionRequest$SourceArn' => '<p>The Amazon Resource Name of the invoker. </p> <important> <p>If you add a permission to a service principal without providing the source ARN, any AWS account that creates a mapping to your function ARN can invoke your Lambda function.</p> </important>', 'CreateEventSourceMappingRequest$EventSourceArn' => '<p>The Amazon Resource Name (ARN) of the event source.</p> <ul> <li> <p> <b>Amazon Kinesis</b> - The ARN of the data stream or a stream consumer.</p> </li> <li> <p> <b>Amazon DynamoDB Streams</b> - The ARN of the stream.</p> </li> <li> <p> <b>Amazon Simple Queue Service</b> - The ARN of the queue.</p> </li> </ul>', 'EventSourceMappingConfiguration$EventSourceArn' => '<p>The Amazon Resource Name (ARN) of the event source.</p>', 'ListEventSourceMappingsRequest$EventSourceArn' => '<p>The Amazon Resource Name (ARN) of the event source.</p> <ul> <li> <p> <b>Amazon Kinesis</b> - The ARN of the data stream or a stream consumer.</p> </li> <li> <p> <b>Amazon DynamoDB Streams</b> - The ARN of the stream.</p> </li> <li> <p> <b>Amazon Simple Queue Service</b> - The ARN of the queue.</p> </li> </ul>', ], ], 'BatchSize' => [ 'base' => NULL, 'refs' => [ 'CreateEventSourceMappingRequest$BatchSize' => '<p>The maximum number of items to retrieve in a single batch.</p> <ul> <li> <p> <b>Amazon Kinesis</b> - Default 100. Max 10,000.</p> </li> <li> <p> <b>Amazon DynamoDB Streams</b> - Default 100. Max 1,000.</p> </li> <li> <p> <b>Amazon Simple Queue Service</b> - Default 10. Max 10.</p> </li> </ul>', 'EventSourceMappingConfiguration$BatchSize' => '<p>The maximum number of items to retrieve in a single batch.</p>', 'UpdateEventSourceMappingRequest$BatchSize' => '<p>The maximum number of items to retrieve in a single batch.</p> <ul> <li> <p> <b>Amazon Kinesis</b> - Default 100. Max 10,000.</p> </li> <li> <p> <b>Amazon DynamoDB Streams</b> - Default 100. Max 1,000.</p> </li> <li> <p> <b>Amazon Simple Queue Service</b> - Default 10. Max 10.</p> </li> </ul>', ], ], 'Blob' => [ 'base' => NULL, 'refs' => [ 'FunctionCode$ZipFile' => '<p>The base64-encoded contents of your zip file containing your deployment package. AWS SDK and AWS CLI clients handle the encoding for you.</p>', 'InvocationRequest$Payload' => '<p>JSON that you want to provide to your Lambda function as input.</p>', 'InvocationResponse$Payload' => '<p> It is the JSON representation of the object returned by the Lambda function. This is present only if the invocation type is <code>RequestResponse</code>. </p> <p>In the event of a function error this field contains a message describing the error. For the <code>Handled</code> errors the Lambda function will report this message. For <code>Unhandled</code> errors AWS Lambda reports the message. </p>', 'LayerVersionContentInput$ZipFile' => '<p>The base64-encoded contents of the layer archive. AWS SDK and AWS CLI clients handle the encoding for you.</p>', 'UpdateFunctionCodeRequest$ZipFile' => '<p>The contents of your zip file containing your deployment package. If you are using the web API directly, the contents of the zip file must be base64-encoded. If you are using the AWS SDKs or the AWS CLI, the SDKs or CLI will do the encoding for you. For more information about creating a .zip file, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/intro-permission-model.html#lambda-intro-execution-role.html">Execution Permissions</a>. </p>', ], ], 'BlobStream' => [ 'base' => NULL, 'refs' => [ 'InvokeAsyncRequest$InvokeArgs' => '<p>JSON that you want to provide to your Lambda function as input.</p>', ], ], 'Boolean' => [ 'base' => NULL, 'refs' => [ 'CreateFunctionRequest$Publish' => '<p>Set to true to publish the first version of the function during creation.</p>', 'UpdateFunctionCodeRequest$Publish' => '<p>This boolean parameter can be used to request AWS Lambda to update the Lambda function and publish a version as an atomic operation.</p>', 'UpdateFunctionCodeRequest$DryRun' => '<p>This boolean parameter can be used to test your request to AWS Lambda to update the Lambda function and publish a version as an atomic operation. It will do all necessary computation and validation of your code but will not upload it or a publish a version. Each time this operation is invoked, the <code>CodeSha256</code> hash value of the provided code will also be computed and returned in the response.</p>', ], ], 'CodeStorageExceededException' => [ 'base' => '<p>You have exceeded your maximum total code size per account. <a href="http://docs.aws.amazon.com/lambda/latest/dg/limits.html">Limits</a> </p>', 'refs' => [], ], 'CompatibleRuntimes' => [ 'base' => NULL, 'refs' => [ 'GetLayerVersionResponse$CompatibleRuntimes' => '<p>The layer\'s compatible runtimes.</p>', 'LayerVersionsListItem$CompatibleRuntimes' => '<p>The layer\'s compatible runtimes.</p>', 'PublishLayerVersionRequest$CompatibleRuntimes' => '<p>A list of compatible <a href="http://docs.aws.amazon.com/lambda/latest/dg/lambda-runtimes.html">function runtimes</a>. Used for filtering with <a>ListLayers</a> and <a>ListLayerVersions</a>.</p>', 'PublishLayerVersionResponse$CompatibleRuntimes' => '<p>The layer\'s compatible runtimes.</p>', ], ], 'Concurrency' => [ 'base' => NULL, 'refs' => [ 'GetFunctionResponse$Concurrency' => '<p>The concurrent execution limit set for this function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/concurrent-executions.html">Managing Concurrency</a>.</p>', ], ], 'CreateAliasRequest' => [ 'base' => NULL, 'refs' => [], ], 'CreateEventSourceMappingRequest' => [ 'base' => NULL, 'refs' => [], ], 'CreateFunctionRequest' => [ 'base' => NULL, 'refs' => [], ], 'Date' => [ 'base' => NULL, 'refs' => [ 'CreateEventSourceMappingRequest$StartingPositionTimestamp' => '<p>With <code>StartingPosition</code> set to <code>AT_TIMESTAMP</code>, the Unix time in seconds from which to start reading.</p>', 'EventSourceMappingConfiguration$LastModified' => '<p>The date that the event source mapping was last updated, in Unix time seconds.</p>', ], ], 'DeadLetterConfig' => [ 'base' => '<p>The <a href="http://docs.aws.amazon.com/lambda/latest/dg/dlq.html">dead letter queue</a> for failed asynchronous invocations.</p>', 'refs' => [ 'CreateFunctionRequest$DeadLetterConfig' => '<p>A dead letter queue configuration that specifies the queue or topic where Lambda sends asynchronous events when they fail processing. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/dlq.html">Dead Letter Queues</a>. </p>', 'FunctionConfiguration$DeadLetterConfig' => '<p>The function\'s dead letter queue.</p>', 'UpdateFunctionConfigurationRequest$DeadLetterConfig' => '<p>A dead letter queue configuration that specifies the queue or topic where Lambda sends asynchronous events when they fail processing. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/dlq.html">Dead Letter Queues</a>.</p>', ], ], 'DeleteAliasRequest' => [ 'base' => NULL, 'refs' => [], ], 'DeleteEventSourceMappingRequest' => [ 'base' => NULL, 'refs' => [], ], 'DeleteFunctionConcurrencyRequest' => [ 'base' => NULL, 'refs' => [], ], 'DeleteFunctionRequest' => [ 'base' => NULL, 'refs' => [], ], 'DeleteLayerVersionRequest' => [ 'base' => NULL, 'refs' => [], ], 'Description' => [ 'base' => NULL, 'refs' => [ 'AliasConfiguration$Description' => '<p>Alias description.</p>', 'CreateAliasRequest$Description' => '<p>Description of the alias.</p>', 'CreateFunctionRequest$Description' => '<p>A description of the function.</p>', 'FunctionConfiguration$Description' => '<p>The function\'s description.</p>', 'GetLayerVersionResponse$Description' => '<p>The description of the version.</p>', 'LayerVersionsListItem$Description' => '<p>The description of the version.</p>', 'PublishLayerVersionRequest$Description' => '<p>The description of the version.</p>', 'PublishLayerVersionResponse$Description' => '<p>The description of the version.</p>', 'PublishVersionRequest$Description' => '<p>The description for the version you are publishing. If not provided, AWS Lambda copies the description from the $LATEST version.</p>', 'UpdateAliasRequest$Description' => '<p>You can change the description of the alias using this parameter.</p>', 'UpdateFunctionConfigurationRequest$Description' => '<p>A short user-defined function description. AWS Lambda does not use this value. Assign a meaningful description as you see fit.</p>', ], ], 'EC2AccessDeniedException' => [ 'base' => '<p>Need additional permissions to configure VPC settings.</p>', 'refs' => [], ], 'EC2ThrottledException' => [ 'base' => '<p>AWS Lambda was throttled by Amazon EC2 during Lambda function initialization using the execution role provided for the Lambda function.</p>', 'refs' => [], ], 'EC2UnexpectedException' => [ 'base' => '<p>AWS Lambda received an unexpected EC2 client exception while setting up for the Lambda function.</p>', 'refs' => [], ], 'ENILimitReachedException' => [ 'base' => '<p>AWS Lambda was not able to create an Elastic Network Interface (ENI) in the VPC, specified as part of Lambda function configuration, because the limit for network interfaces has been reached.</p>', 'refs' => [], ], 'Enabled' => [ 'base' => NULL, 'refs' => [ 'CreateEventSourceMappingRequest$Enabled' => '<p>Disables the event source mapping to pause polling and invocation.</p>', 'UpdateEventSourceMappingRequest$Enabled' => '<p>Disables the event source mapping to pause polling and invocation.</p>', ], ], 'Environment' => [ 'base' => '<p>A function\'s environment variable settings.</p>', 'refs' => [ 'CreateFunctionRequest$Environment' => '<p>Environment variables that are accessible from function code during execution.</p>', 'UpdateFunctionConfigurationRequest$Environment' => '<p>The parent object that contains your environment\'s configuration settings.</p>', ], ], 'EnvironmentError' => [ 'base' => '<p>Error messages for environment variables that could not be applied.</p>', 'refs' => [ 'EnvironmentResponse$Error' => '<p>Error messages for environment variables that could not be applied.</p>', ], ], 'EnvironmentResponse' => [ 'base' => '<p>The results of a configuration update that applied environment variables.</p>', 'refs' => [ 'FunctionConfiguration$Environment' => '<p>The function\'s environment variables.</p>', ], ], 'EnvironmentVariableName' => [ 'base' => NULL, 'refs' => [ 'EnvironmentVariables$key' => NULL, ], ], 'EnvironmentVariableValue' => [ 'base' => NULL, 'refs' => [ 'EnvironmentVariables$value' => NULL, ], ], 'EnvironmentVariables' => [ 'base' => NULL, 'refs' => [ 'Environment$Variables' => '<p>Environment variable key-value pairs.</p>', 'EnvironmentResponse$Variables' => '<p>Environment variable key-value pairs.</p>', ], ], 'EventSourceMappingConfiguration' => [ 'base' => '<p>A mapping between an AWS resource and an AWS Lambda function. See <a>CreateEventSourceMapping</a> for details.</p>', 'refs' => [ 'EventSourceMappingsList$member' => NULL, ], ], 'EventSourceMappingsList' => [ 'base' => NULL, 'refs' => [ 'ListEventSourceMappingsResponse$EventSourceMappings' => '<p>A list of event source mappings.</p>', ], ], 'EventSourcePosition' => [ 'base' => NULL, 'refs' => [ 'CreateEventSourceMappingRequest$StartingPosition' => '<p>The position in a stream from which to start reading. Required for Amazon Kinesis and Amazon DynamoDB Streams sources. <code>AT_TIMESTAMP</code> is only supported for Amazon Kinesis streams.</p>', ], ], 'EventSourceToken' => [ 'base' => NULL, 'refs' => [ 'AddPermissionRequest$EventSourceToken' => '<p>A unique token that must be supplied by the principal invoking the function. This is currently only used for Alexa Smart Home functions.</p>', ], ], 'FunctionArn' => [ 'base' => NULL, 'refs' => [ 'AliasConfiguration$AliasArn' => '<p>Lambda function ARN that is qualified using the alias name as the suffix. For example, if you create an alias called <code>BETA</code> that points to a helloworld function version, the ARN is <code>arn:aws:lambda:aws-regions:acct-id:function:helloworld:BETA</code>.</p>', 'EventSourceMappingConfiguration$FunctionArn' => '<p>The ARN of the Lambda function.</p>', 'FunctionConfiguration$MasterArn' => '<p>The ARN of the master function.</p>', 'ListTagsRequest$Resource' => '<p>The ARN (Amazon Resource Name) of the function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>.</p>', 'TagResourceRequest$Resource' => '<p>The ARN (Amazon Resource Name) of the Lambda function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>.</p>', 'UntagResourceRequest$Resource' => '<p>The ARN (Amazon Resource Name) of the function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>.</p>', ], ], 'FunctionCode' => [ 'base' => '<p>The code for the Lambda function. You can specify either an S3 location, or upload a deployment package directly.</p>', 'refs' => [ 'CreateFunctionRequest$Code' => '<p>The code for the function.</p>', ], ], 'FunctionCodeLocation' => [ 'base' => '<p>The object for the Lambda function location.</p>', 'refs' => [ 'GetFunctionResponse$Code' => '<p>The function\'s code.</p>', ], ], 'FunctionConfiguration' => [ 'base' => '<p>A Lambda function\'s configuration settings.</p>', 'refs' => [ 'FunctionList$member' => NULL, 'GetFunctionResponse$Configuration' => '<p>The function\'s configuration.</p>', ], ], 'FunctionList' => [ 'base' => NULL, 'refs' => [ 'ListFunctionsResponse$Functions' => '<p>A list of Lambda functions.</p>', 'ListVersionsByFunctionResponse$Versions' => '<p>A list of Lambda function versions.</p>', ], ], 'FunctionName' => [ 'base' => NULL, 'refs' => [ 'AddPermissionRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'CreateAliasRequest$FunctionName' => '<p>The name of the lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'CreateEventSourceMappingRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Version or Alias ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction:PROD</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it\'s limited to 64 characters in length.</p>', 'CreateFunctionRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'DeleteAliasRequest$FunctionName' => '<p>The name of the lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'DeleteFunctionConcurrencyRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'DeleteFunctionRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'GetAliasRequest$FunctionName' => '<p>The name of the lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'ListAliasesRequest$FunctionName' => '<p>The name of the lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'ListEventSourceMappingsRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Version or Alias ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction:PROD</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it\'s limited to 64 characters in length.</p>', 'PublishVersionRequest$FunctionName' => '<p>The name of the lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'PutFunctionConcurrencyRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'RemovePermissionRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'UpdateAliasRequest$FunctionName' => '<p>The name of the lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'UpdateEventSourceMappingRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Version or Alias ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction:PROD</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it\'s limited to 64 characters in length.</p>', 'UpdateFunctionCodeRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'UpdateFunctionConfigurationRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', ], ], 'FunctionVersion' => [ 'base' => NULL, 'refs' => [ 'ListFunctionsRequest$FunctionVersion' => '<p>Set to <code>ALL</code> to list all published versions. If not specified, only the latest unpublished version ARN is returned.</p>', ], ], 'GetAccountSettingsRequest' => [ 'base' => NULL, 'refs' => [], ], 'GetAccountSettingsResponse' => [ 'base' => NULL, 'refs' => [], ], 'GetAliasRequest' => [ 'base' => NULL, 'refs' => [], ], 'GetEventSourceMappingRequest' => [ 'base' => NULL, 'refs' => [], ], 'GetFunctionConfigurationRequest' => [ 'base' => NULL, 'refs' => [], ], 'GetFunctionRequest' => [ 'base' => NULL, 'refs' => [], ], 'GetFunctionResponse' => [ 'base' => '<p>This response contains the object for the Lambda function location (see <a>FunctionCodeLocation</a>.</p>', 'refs' => [], ], 'GetLayerVersionPolicyRequest' => [ 'base' => NULL, 'refs' => [], ], 'GetLayerVersionPolicyResponse' => [ 'base' => NULL, 'refs' => [], ], 'GetLayerVersionRequest' => [ 'base' => NULL, 'refs' => [], ], 'GetLayerVersionResponse' => [ 'base' => NULL, 'refs' => [], ], 'GetPolicyRequest' => [ 'base' => NULL, 'refs' => [], ], 'GetPolicyResponse' => [ 'base' => NULL, 'refs' => [], ], 'Handler' => [ 'base' => NULL, 'refs' => [ 'CreateFunctionRequest$Handler' => '<p>The name of the method within your code that Lambda calls to execute your function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/programming-model-v2.html">Programming Model</a>.</p>', 'FunctionConfiguration$Handler' => '<p>The function Lambda calls to begin executing your function.</p>', 'UpdateFunctionConfigurationRequest$Handler' => '<p>The function that Lambda calls to begin executing your function. For Node.js, it is the <code>module-name.export</code> value in your function. </p>', ], ], 'HttpStatus' => [ 'base' => NULL, 'refs' => [ 'InvokeAsyncResponse$Status' => '<p>It will be 202 upon success.</p>', ], ], 'Integer' => [ 'base' => NULL, 'refs' => [ 'AccountLimit$ConcurrentExecutions' => '<p>Number of simultaneous executions of your function per region. The default limit is 1000.</p>', 'InvocationResponse$StatusCode' => '<p>The HTTP status code will be in the 200 range for successful request. For the <code>RequestResponse</code> invocation type this status code will be 200. For the <code>Event</code> invocation type this status code will be 202. For the <code>DryRun</code> invocation type the status code will be 204. </p>', ], ], 'InvalidParameterValueException' => [ 'base' => '<p>One of the parameters in the request is invalid. For example, if you provided an IAM role for AWS Lambda to assume in the <code>CreateFunction</code> or the <code>UpdateFunctionConfiguration</code> API, that AWS Lambda is unable to assume you will get this exception.</p>', 'refs' => [], ], 'InvalidRequestContentException' => [ 'base' => '<p>The request body could not be parsed as JSON.</p>', 'refs' => [], ], 'InvalidRuntimeException' => [ 'base' => '<p>The runtime or runtime version specified is not supported.</p>', 'refs' => [], ], 'InvalidSecurityGroupIDException' => [ 'base' => '<p>The Security Group ID provided in the Lambda function VPC configuration is invalid.</p>', 'refs' => [], ], 'InvalidSubnetIDException' => [ 'base' => '<p>The Subnet ID provided in the Lambda function VPC configuration is invalid.</p>', 'refs' => [], ], 'InvalidZipFileException' => [ 'base' => '<p>AWS Lambda could not unzip the deployment package.</p>', 'refs' => [], ], 'InvocationRequest' => [ 'base' => NULL, 'refs' => [], ], 'InvocationResponse' => [ 'base' => '<p>Upon success, returns an empty response. Otherwise, throws an exception.</p>', 'refs' => [], ], 'InvocationType' => [ 'base' => NULL, 'refs' => [ 'InvocationRequest$InvocationType' => '<p>Choose from the following options.</p> <ul> <li> <p> <code>RequestResponse</code> (default) - Invoke the function synchronously. Keep the connection open until the function returns a response or times out.</p> </li> <li> <p> <code>Event</code> - Invoke the function asynchronously. Send events that fail multiple times to the function\'s dead-letter queue (if configured).</p> </li> <li> <p> <code>DryRun</code> - Validate parameter values and verify that the user or role has permission to invoke the function.</p> </li> </ul>', ], ], 'InvokeAsyncRequest' => [ 'base' => NULL, 'refs' => [], ], 'InvokeAsyncResponse' => [ 'base' => '<p>Upon success, it returns empty response. Otherwise, throws an exception.</p>', 'refs' => [], ], 'KMSAccessDeniedException' => [ 'base' => '<p>Lambda was unable to decrypt the environment variables because KMS access was denied. Check the Lambda function\'s KMS permissions.</p>', 'refs' => [], ], 'KMSDisabledException' => [ 'base' => '<p>Lambda was unable to decrypt the environment variables because the KMS key used is disabled. Check the Lambda function\'s KMS key settings.</p>', 'refs' => [], ], 'KMSInvalidStateException' => [ 'base' => '<p>Lambda was unable to decrypt the environment variables because the KMS key used is in an invalid state for Decrypt. Check the function\'s KMS key settings.</p>', 'refs' => [], ], 'KMSKeyArn' => [ 'base' => NULL, 'refs' => [ 'CreateFunctionRequest$KMSKeyArn' => '<p>The ARN of the KMS key used to encrypt your function\'s environment variables. If not provided, AWS Lambda will use a default service key.</p>', 'FunctionConfiguration$KMSKeyArn' => '<p>The KMS key used to encrypt the function\'s environment variables. Only returned if you\'ve configured a customer managed CMK.</p>', 'UpdateFunctionConfigurationRequest$KMSKeyArn' => '<p>The Amazon Resource Name (ARN) of the KMS key used to encrypt your function\'s environment variables. If you elect to use the AWS Lambda default service key, pass in an empty string ("") for this parameter.</p>', ], ], 'KMSNotFoundException' => [ 'base' => '<p>Lambda was unable to decrypt the environment variables because the KMS key was not found. Check the function\'s KMS key settings. </p>', 'refs' => [], ], 'Layer' => [ 'base' => '<p>A function layer.</p>', 'refs' => [ 'LayersReferenceList$member' => NULL, ], ], 'LayerArn' => [ 'base' => NULL, 'refs' => [ 'GetLayerVersionResponse$LayerArn' => '<p>The Amazon Resource Name (ARN) of the function layer.</p>', 'LayersListItem$LayerArn' => '<p>The Amazon Resource Name (ARN) of the function layer.</p>', 'PublishLayerVersionResponse$LayerArn' => '<p>The Amazon Resource Name (ARN) of the function layer.</p>', ], ], 'LayerList' => [ 'base' => NULL, 'refs' => [ 'CreateFunctionRequest$Layers' => '<p>A list of <a href="http://docs.aws.amazon.com/lambda/latest/dg/configuration-layers.html">function layers</a> to add to the function\'s execution environment.</p>', 'UpdateFunctionConfigurationRequest$Layers' => '<p>A list of <a href="http://docs.aws.amazon.com/lambda/latest/dg/configuration-layers.html">function layers</a> to add to the function\'s execution environment.</p>', ], ], 'LayerName' => [ 'base' => NULL, 'refs' => [ 'AddLayerVersionPermissionRequest$LayerName' => '<p>The name of the layer.</p>', 'DeleteLayerVersionRequest$LayerName' => '<p>The name of the layer.</p>', 'GetLayerVersionPolicyRequest$LayerName' => '<p>The name of the layer.</p>', 'GetLayerVersionRequest$LayerName' => '<p>The name of the layer.</p>', 'LayersListItem$LayerName' => '<p>The name of the layer.</p>', 'ListLayerVersionsRequest$LayerName' => '<p>The name of the layer.</p>', 'PublishLayerVersionRequest$LayerName' => '<p>The name of the layer.</p>', 'RemoveLayerVersionPermissionRequest$LayerName' => '<p>The name of the layer.</p>', ], ], 'LayerPermissionAllowedAction' => [ 'base' => NULL, 'refs' => [ 'AddLayerVersionPermissionRequest$Action' => '<p>The API action that grants access to the layer. For example, <code>lambda:GetLayerVersion</code>.</p>', ], ], 'LayerPermissionAllowedPrincipal' => [ 'base' => NULL, 'refs' => [ 'AddLayerVersionPermissionRequest$Principal' => '<p>An account ID, or <code>*</code> to grant permission to all AWS accounts.</p>', ], ], 'LayerVersionArn' => [ 'base' => NULL, 'refs' => [ 'GetLayerVersionResponse$LayerVersionArn' => '<p>The ARN of the layer version.</p>', 'Layer$Arn' => '<p>The Amazon Resource Name (ARN) of the function layer.</p>', 'LayerList$member' => NULL, 'LayerVersionsListItem$LayerVersionArn' => '<p>The ARN of the layer version.</p>', 'PublishLayerVersionResponse$LayerVersionArn' => '<p>The ARN of the layer version.</p>', ], ], 'LayerVersionContentInput' => [ 'base' => '<p>A ZIP archive that contains the contents of the function layer. You can specify either an Amazon S3 location, or upload a layer archive directly.</p>', 'refs' => [ 'PublishLayerVersionRequest$Content' => '<p>The function layer archive.</p>', ], ], 'LayerVersionContentOutput' => [ 'base' => '<p>Details about a layer version.</p>', 'refs' => [ 'GetLayerVersionResponse$Content' => '<p>Details about the layer version.</p>', 'PublishLayerVersionResponse$Content' => '<p>Details about the layer version.</p>', ], ], 'LayerVersionNumber' => [ 'base' => NULL, 'refs' => [ 'AddLayerVersionPermissionRequest$VersionNumber' => '<p>The version number.</p>', 'DeleteLayerVersionRequest$VersionNumber' => '<p>The version number.</p>', 'GetLayerVersionPolicyRequest$VersionNumber' => '<p>The version number.</p>', 'GetLayerVersionRequest$VersionNumber' => '<p>The version number.</p>', 'GetLayerVersionResponse$Version' => '<p>The version number.</p>', 'LayerVersionsListItem$Version' => '<p>The version number.</p>', 'PublishLayerVersionResponse$Version' => '<p>The version number.</p>', 'RemoveLayerVersionPermissionRequest$VersionNumber' => '<p>The version number.</p>', ], ], 'LayerVersionsList' => [ 'base' => NULL, 'refs' => [ 'ListLayerVersionsResponse$LayerVersions' => '<p>A list of versions.</p>', ], ], 'LayerVersionsListItem' => [ 'base' => '<p>Details about a layer version.</p>', 'refs' => [ 'LayerVersionsList$member' => NULL, 'LayersListItem$LatestMatchingVersion' => '<p>The newest version of the layer.</p>', ], ], 'LayersList' => [ 'base' => NULL, 'refs' => [ 'ListLayersResponse$Layers' => '<p>A list of function layers.</p>', ], ], 'LayersListItem' => [ 'base' => '<p>Details about a function layer.</p>', 'refs' => [ 'LayersList$member' => NULL, ], ], 'LayersReferenceList' => [ 'base' => NULL, 'refs' => [ 'FunctionConfiguration$Layers' => '<p>A list of <a href="http://docs.aws.amazon.com/lambda/latest/dg/configuration-layers.html">function layers</a>.</p>', ], ], 'LicenseInfo' => [ 'base' => NULL, 'refs' => [ 'GetLayerVersionResponse$LicenseInfo' => '<p>The layer\'s software license.</p>', 'LayerVersionsListItem$LicenseInfo' => '<p>The layer\'s open-source license.</p>', 'PublishLayerVersionRequest$LicenseInfo' => '<p>The layer\'s software license. It can be any of the following:</p> <ul> <li> <p>An <a href="https://spdx.org/licenses/">SPDX license identifier</a>. For example, <code>MIT</code>.</p> </li> <li> <p>The URL of a license hosted on the internet. For example, <code>https://opensource.org/licenses/MIT</code>.</p> </li> <li> <p>The full text of the license.</p> </li> </ul>', 'PublishLayerVersionResponse$LicenseInfo' => '<p>The layer\'s software license.</p>', ], ], 'ListAliasesRequest' => [ 'base' => NULL, 'refs' => [], ], 'ListAliasesResponse' => [ 'base' => NULL, 'refs' => [], ], 'ListEventSourceMappingsRequest' => [ 'base' => NULL, 'refs' => [], ], 'ListEventSourceMappingsResponse' => [ 'base' => NULL, 'refs' => [], ], 'ListFunctionsRequest' => [ 'base' => NULL, 'refs' => [], ], 'ListFunctionsResponse' => [ 'base' => '<p>A list of Lambda functions.</p>', 'refs' => [], ], 'ListLayerVersionsRequest' => [ 'base' => NULL, 'refs' => [], ], 'ListLayerVersionsResponse' => [ 'base' => NULL, 'refs' => [], ], 'ListLayersRequest' => [ 'base' => NULL, 'refs' => [], ], 'ListLayersResponse' => [ 'base' => NULL, 'refs' => [], ], 'ListTagsRequest' => [ 'base' => NULL, 'refs' => [], ], 'ListTagsResponse' => [ 'base' => NULL, 'refs' => [], ], 'ListVersionsByFunctionRequest' => [ 'base' => NULL, 'refs' => [], ], 'ListVersionsByFunctionResponse' => [ 'base' => NULL, 'refs' => [], ], 'LogType' => [ 'base' => NULL, 'refs' => [ 'InvocationRequest$LogType' => '<p>You can set this optional parameter to <code>Tail</code> in the request only if you specify the <code>InvocationType</code> parameter with value <code>RequestResponse</code>. In this case, AWS Lambda returns the base64-encoded last 4 KB of log data produced by your Lambda function in the <code>x-amz-log-result</code> header. </p>', ], ], 'Long' => [ 'base' => NULL, 'refs' => [ 'AccountLimit$TotalCodeSize' => '<p>Maximum size, in bytes, of a code package you can upload per region. The default size is 75 GB. </p>', 'AccountLimit$CodeSizeUnzipped' => '<p>Size, in bytes, of code/dependencies that you can zip into a deployment package (uncompressed zip/jar size) for uploading. The default limit is 250 MB.</p>', 'AccountLimit$CodeSizeZipped' => '<p>Size, in bytes, of a single zipped code/dependencies package you can upload for your Lambda function(.zip/.jar file). Try using Amazon S3 for uploading larger files. Default limit is 50 MB.</p>', 'AccountUsage$TotalCodeSize' => '<p>Total size, in bytes, of the account\'s deployment packages per region.</p>', 'AccountUsage$FunctionCount' => '<p>The number of your account\'s existing functions per region.</p>', 'FunctionConfiguration$CodeSize' => '<p>The size of the function\'s deployment package in bytes.</p>', 'Layer$CodeSize' => '<p>The size of the layer archive in bytes.</p>', 'LayerVersionContentOutput$CodeSize' => '<p>The size of the layer archive in bytes.</p>', ], ], 'MasterRegion' => [ 'base' => NULL, 'refs' => [ 'ListFunctionsRequest$MasterRegion' => '<p>Specify a region (e.g. <code>us-east-2</code>) to only list functions that were created in that region, or <code>ALL</code> to include functions replicated from any region. If specified, you also must specify the <code>FunctionVersion</code>.</p>', ], ], 'MaxLayerListItems' => [ 'base' => NULL, 'refs' => [ 'ListLayerVersionsRequest$MaxItems' => '<p>The maximum number of versions to return.</p>', 'ListLayersRequest$MaxItems' => '<p>The maximum number of layers to return.</p>', ], ], 'MaxListItems' => [ 'base' => NULL, 'refs' => [ 'ListAliasesRequest$MaxItems' => '<p>Optional integer. Specifies the maximum number of aliases to return in response. This parameter value must be greater than 0.</p>', 'ListEventSourceMappingsRequest$MaxItems' => '<p>The maximum number of event source mappings to return.</p>', 'ListFunctionsRequest$MaxItems' => '<p>Optional integer. Specifies the maximum number of AWS Lambda functions to return in response. This parameter value must be greater than 0. The absolute maximum of AWS Lambda functions that can be returned is 50.</p>', 'ListVersionsByFunctionRequest$MaxItems' => '<p>Optional integer. Specifies the maximum number of AWS Lambda function versions to return in response. This parameter value must be greater than 0.</p>', ], ], 'MemorySize' => [ 'base' => NULL, 'refs' => [ 'CreateFunctionRequest$MemorySize' => '<p>The amount of memory that your function has access to. Increasing the function\'s memory also increases it\'s CPU allocation. The default value is 128 MB. The value must be a multiple of 64 MB.</p>', 'FunctionConfiguration$MemorySize' => '<p>The memory allocated to the function</p>', 'UpdateFunctionConfigurationRequest$MemorySize' => '<p>The amount of memory, in MB, your Lambda function is given. AWS Lambda uses this memory size to infer the amount of CPU allocated to your function. Your function use-case determines your CPU and memory requirements. For example, a database operation might need less memory compared to an image processing function. The default value is 128 MB. The value must be a multiple of 64 MB.</p>', ], ], 'NameSpacedFunctionArn' => [ 'base' => NULL, 'refs' => [ 'FunctionConfiguration$FunctionArn' => '<p>The function\'s Amazon Resource Name.</p>', ], ], 'NamespacedFunctionName' => [ 'base' => NULL, 'refs' => [ 'FunctionConfiguration$FunctionName' => '<p>The name of the function.</p>', 'GetFunctionConfigurationRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'GetFunctionRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'GetPolicyRequest$FunctionName' => '<p>The name of the lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'InvocationRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'InvokeAsyncRequest$FunctionName' => '<p>The name of the Lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', 'ListVersionsByFunctionRequest$FunctionName' => '<p>The name of the lambda function.</p> <p class="title"> <b>Name formats</b> </p> <ul> <li> <p> <b>Function name</b> - <code>MyFunction</code>.</p> </li> <li> <p> <b>Function ARN</b> - <code>arn:aws:lambda:us-west-2:123456789012:function:MyFunction</code>.</p> </li> <li> <p> <b>Partial ARN</b> - <code>123456789012:function:MyFunction</code>.</p> </li> </ul> <p>The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.</p>', ], ], 'NamespacedStatementId' => [ 'base' => NULL, 'refs' => [ 'RemovePermissionRequest$StatementId' => '<p>Statement ID of the permission to remove.</p>', ], ], 'OrganizationId' => [ 'base' => NULL, 'refs' => [ 'AddLayerVersionPermissionRequest$OrganizationId' => '<p>With the principal set to <code>*</code>, grant permission to all accounts in the specified organization.</p>', ], ], 'PolicyLengthExceededException' => [ 'base' => '<p>Lambda function access policy is limited to 20 KB.</p>', 'refs' => [], ], 'PreconditionFailedException' => [ 'base' => '<p>The RevisionId provided does not match the latest RevisionId for the Lambda function or alias. Call the <code>GetFunction</code> or the <code>GetAlias</code> API to retrieve the latest RevisionId for your resource.</p>', 'refs' => [], ], 'Principal' => [ 'base' => NULL, 'refs' => [ 'AddPermissionRequest$Principal' => '<p>The principal who is getting this permission. The principal can be an AWS service (e.g. <code>s3.amazonaws.com</code> or <code>sns.amazonaws.com</code>) for service triggers, or an account ID for cross-account access. If you specify a service as a principal, use the <code>SourceArn</code> parameter to limit who can invoke the function through that service.</p>', ], ], 'PublishLayerVersionRequest' => [ 'base' => NULL, 'refs' => [], ], 'PublishLayerVersionResponse' => [ 'base' => NULL, 'refs' => [], ], 'PublishVersionRequest' => [ 'base' => NULL, 'refs' => [], ], 'PutFunctionConcurrencyRequest' => [ 'base' => NULL, 'refs' => [], ], 'Qualifier' => [ 'base' => NULL, 'refs' => [ 'AddPermissionRequest$Qualifier' => '<p>Specify a version or alias to add permissions to a published version of the function.</p>', 'DeleteFunctionRequest$Qualifier' => '<p>Specify a version to delete. You cannot delete a version that is referenced by an alias.</p>', 'GetFunctionConfigurationRequest$Qualifier' => '<p>Specify a version or alias to get details about a published version of the function.</p>', 'GetFunctionRequest$Qualifier' => '<p>Specify a version or alias to get details about a published version of the function.</p>', 'GetPolicyRequest$Qualifier' => '<p>You can specify this optional query parameter to specify a function version or an alias name in which case this API will return all permissions associated with the specific qualified ARN. If you don\'t provide this parameter, the API will return permissions that apply to the unqualified function ARN.</p>', 'InvocationRequest$Qualifier' => '<p>Specify a version or alias to invoke a published version of the function.</p>', 'RemovePermissionRequest$Qualifier' => '<p>Specify a version or alias to remove permissions from a published version of the function.</p>', ], ], 'RemoveLayerVersionPermissionRequest' => [ 'base' => NULL, 'refs' => [], ], 'RemovePermissionRequest' => [ 'base' => NULL, 'refs' => [], ], 'RequestTooLargeException' => [ 'base' => '<p>The request payload exceeded the <code>Invoke</code> request body JSON input limit. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/limits.html">Limits</a>. </p>', 'refs' => [], ], 'ReservedConcurrentExecutions' => [ 'base' => NULL, 'refs' => [ 'Concurrency$ReservedConcurrentExecutions' => '<p>The number of concurrent executions reserved for this function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/concurrent-executions.html">Managing Concurrency</a>.</p>', 'PutFunctionConcurrencyRequest$ReservedConcurrentExecutions' => '<p>The concurrent execution limit reserved for this function.</p>', ], ], 'ResourceArn' => [ 'base' => NULL, 'refs' => [ 'DeadLetterConfig$TargetArn' => '<p>The Amazon Resource Name (ARN) of an Amazon SQS queue or Amazon SNS topic.</p>', ], ], 'ResourceConflictException' => [ 'base' => '<p>The resource already exists.</p>', 'refs' => [], ], 'ResourceInUseException' => [ 'base' => '<p>The operation conflicts with the resource\'s availability. For example, you attempted to update an EventSoure Mapping in CREATING, or tried to delete a EventSoure mapping currently in the UPDATING state. </p>', 'refs' => [], ], 'ResourceNotFoundException' => [ 'base' => '<p>The resource (for example, a Lambda function or access policy statement) specified in the request does not exist.</p>', 'refs' => [], ], 'RoleArn' => [ 'base' => NULL, 'refs' => [ 'CreateFunctionRequest$Role' => '<p>The Amazon Resource Name (ARN) of the function\'s <a href="http://docs.aws.amazon.com/lambda/latest/dg/intro-permission-model.html#lambda-intro-execution-role">execution role</a>.</p>', 'FunctionConfiguration$Role' => '<p>The function\'s execution role.</p>', 'UpdateFunctionConfigurationRequest$Role' => '<p>The Amazon Resource Name (ARN) of the IAM role that Lambda will assume when it executes your function.</p>', ], ], 'Runtime' => [ 'base' => NULL, 'refs' => [ 'CompatibleRuntimes$member' => NULL, 'CreateFunctionRequest$Runtime' => '<p>The runtime version for the function.</p>', 'FunctionConfiguration$Runtime' => '<p>The runtime environment for the Lambda function.</p>', 'ListLayerVersionsRequest$CompatibleRuntime' => '<p>A runtime identifier. For example, <code>go1.x</code>.</p>', 'ListLayersRequest$CompatibleRuntime' => '<p>A runtime identifier. For example, <code>go1.x</code>.</p>', 'UpdateFunctionConfigurationRequest$Runtime' => '<p>The runtime version for the function.</p>', ], ], 'S3Bucket' => [ 'base' => NULL, 'refs' => [ 'FunctionCode$S3Bucket' => '<p>An Amazon S3 bucket in the same region as your function.</p>', 'LayerVersionContentInput$S3Bucket' => '<p>The Amazon S3 bucket of the layer archive.</p>', 'UpdateFunctionCodeRequest$S3Bucket' => '<p>Amazon S3 bucket name where the .zip file containing your deployment package is stored. This bucket must reside in the same AWS Region where you are creating the Lambda function.</p>', ], ], 'S3Key' => [ 'base' => NULL, 'refs' => [ 'FunctionCode$S3Key' => '<p>The Amazon S3 key of the deployment package.</p>', 'LayerVersionContentInput$S3Key' => '<p>The Amazon S3 key of the layer archive.</p>', 'UpdateFunctionCodeRequest$S3Key' => '<p>The Amazon S3 object (the deployment package) key name you want to upload.</p>', ], ], 'S3ObjectVersion' => [ 'base' => NULL, 'refs' => [ 'FunctionCode$S3ObjectVersion' => '<p>For versioned objects, the version of the deployment package object to use.</p>', 'LayerVersionContentInput$S3ObjectVersion' => '<p>For versioned objects, the version of the layer archive object to use.</p>', 'UpdateFunctionCodeRequest$S3ObjectVersion' => '<p>The Amazon S3 object (the deployment package) version you want to upload.</p>', ], ], 'SecurityGroupId' => [ 'base' => NULL, 'refs' => [ 'SecurityGroupIds$member' => NULL, ], ], 'SecurityGroupIds' => [ 'base' => NULL, 'refs' => [ 'VpcConfig$SecurityGroupIds' => '<p>A list of VPC security groups IDs.</p>', 'VpcConfigResponse$SecurityGroupIds' => '<p>A list of VPC security groups IDs.</p>', ], ], 'SensitiveString' => [ 'base' => NULL, 'refs' => [ 'EnvironmentError$Message' => '<p>The error message.</p>', ], ], 'ServiceException' => [ 'base' => '<p>The AWS Lambda service encountered an internal error.</p>', 'refs' => [], ], 'SourceOwner' => [ 'base' => NULL, 'refs' => [ 'AddPermissionRequest$SourceAccount' => '<p>This parameter is used for S3 and SES. The AWS account ID (without a hyphen) of the source owner. For example, if the <code>SourceArn</code> identifies a bucket, then this is the bucket owner\'s account ID. You can use this additional condition to ensure the bucket you specify is owned by a specific account (it is possible the bucket owner deleted the bucket and some other AWS account created the bucket). You can also use this condition to specify all sources (that is, you don\'t specify the <code>SourceArn</code>) owned by a specific account. </p>', ], ], 'StatementId' => [ 'base' => NULL, 'refs' => [ 'AddLayerVersionPermissionRequest$StatementId' => '<p>An identifier that distinguishes the policy from others on the same layer version.</p>', 'AddPermissionRequest$StatementId' => '<p>A unique statement identifier.</p>', 'RemoveLayerVersionPermissionRequest$StatementId' => '<p>The identifier that was specified when the statement was added.</p>', ], ], 'String' => [ 'base' => NULL, 'refs' => [ 'AddLayerVersionPermissionRequest$RevisionId' => '<p>Only update the policy if the revision ID matches the ID specified. Use this option to avoid modifying a policy that has changed since you last read it.</p>', 'AddLayerVersionPermissionResponse$Statement' => '<p>The permission statement.</p>', 'AddLayerVersionPermissionResponse$RevisionId' => '<p>A unique identifier for the current revision of the policy.</p>', 'AddPermissionRequest$RevisionId' => '<p>An optional value you can use to ensure you are updating the latest update of the function version or alias. If the <code>RevisionID</code> you pass doesn\'t match the latest <code>RevisionId</code> of the function or alias, it will fail with an error message, advising you to retrieve the latest function version or alias <code>RevisionID</code> using either <a>GetFunction</a> or <a>GetAlias</a> </p>', 'AddPermissionResponse$Statement' => '<p>The permission statement you specified in the request. The response returns the same as a string using a backslash ("\\") as an escape character in the JSON.</p>', 'AliasConfiguration$RevisionId' => '<p>Represents the latest updated revision of the function or alias.</p>', 'CodeStorageExceededException$Type' => '<p>The exception type.</p>', 'CodeStorageExceededException$message' => NULL, 'DeleteEventSourceMappingRequest$UUID' => '<p>The identifier of the event source mapping.</p>', 'EC2AccessDeniedException$Type' => NULL, 'EC2AccessDeniedException$Message' => NULL, 'EC2ThrottledException$Type' => NULL, 'EC2ThrottledException$Message' => NULL, 'EC2UnexpectedException$Type' => NULL, 'EC2UnexpectedException$Message' => NULL, 'EC2UnexpectedException$EC2ErrorCode' => NULL, 'ENILimitReachedException$Type' => NULL, 'ENILimitReachedException$Message' => NULL, 'EnvironmentError$ErrorCode' => '<p>The error code.</p>', 'EventSourceMappingConfiguration$UUID' => '<p>The identifier of the event source mapping.</p>', 'EventSourceMappingConfiguration$LastProcessingResult' => '<p>The result of the last AWS Lambda invocation of your Lambda function.</p>', 'EventSourceMappingConfiguration$State' => '<p>The state of the event source mapping. It can be one of the following: <code>Creating</code>, <code>Enabling</code>, <code>Enabled</code>, <code>Disabling</code>, <code>Disabled</code>, <code>Updating</code>, or <code>Deleting</code>.</p>', 'EventSourceMappingConfiguration$StateTransitionReason' => '<p>The cause of the last state change, either <code>User initiated</code> or <code>Lambda initiated</code>.</p>', 'FunctionCodeLocation$RepositoryType' => '<p>The repository from which you can download the function.</p>', 'FunctionCodeLocation$Location' => '<p>The presigned URL you can use to download the function\'s .zip file that you previously uploaded. The URL is valid for up to 10 minutes.</p>', 'FunctionConfiguration$CodeSha256' => '<p>The SHA256 hash of the function\'s deployment package.</p>', 'FunctionConfiguration$RevisionId' => '<p>Represents the latest updated revision of the function or alias.</p>', 'GetEventSourceMappingRequest$UUID' => '<p>The identifier of the event source mapping.</p>', 'GetLayerVersionPolicyResponse$Policy' => '<p>The policy document.</p>', 'GetLayerVersionPolicyResponse$RevisionId' => '<p>A unique identifier for the current revision of the policy.</p>', 'GetPolicyResponse$Policy' => '<p>The resource policy associated with the specified function. The response returns the same as a string using a backslash ("\\") as an escape character in the JSON.</p>', 'GetPolicyResponse$RevisionId' => '<p>Represents the latest updated revision of the function or alias.</p>', 'InvalidParameterValueException$Type' => '<p>The exception type.</p>', 'InvalidParameterValueException$message' => '<p>The exception message.</p>', 'InvalidRequestContentException$Type' => '<p>The exception type.</p>', 'InvalidRequestContentException$message' => '<p>The exception message.</p>', 'InvalidRuntimeException$Type' => NULL, 'InvalidRuntimeException$Message' => NULL, 'InvalidSecurityGroupIDException$Type' => NULL, 'InvalidSecurityGroupIDException$Message' => NULL, 'InvalidSubnetIDException$Type' => NULL, 'InvalidSubnetIDException$Message' => NULL, 'InvalidZipFileException$Type' => NULL, 'InvalidZipFileException$Message' => NULL, 'InvocationRequest$ClientContext' => '<p>Using the <code>ClientContext</code> you can pass client-specific information to the Lambda function you are invoking. You can then process the client information in your Lambda function as you choose through the context variable. For an example of a <code>ClientContext</code> JSON, see <a href="http://docs.aws.amazon.com/mobileanalytics/latest/ug/PutEvents.html">PutEvents</a> in the <i>Amazon Mobile Analytics API Reference and User Guide</i>.</p> <p>The ClientContext JSON must be base64-encoded and has a maximum size of 3583 bytes.</p> <note> <p> <code>ClientContext</code> information is returned only if you use the synchronous (<code>RequestResponse</code>) invocation type.</p> </note>', 'InvocationResponse$FunctionError' => '<p>Indicates whether an error occurred while executing the Lambda function. If an error occurred this field will have one of two values; <code>Handled</code> or <code>Unhandled</code>. <code>Handled</code> errors are errors that are reported by the function while the <code>Unhandled</code> errors are those detected and reported by AWS Lambda. Unhandled errors include out of memory errors and function timeouts. For information about how to report an <code>Handled</code> error, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/programming-model.html">Programming Model</a>. </p>', 'InvocationResponse$LogResult' => '<p> It is the base64-encoded logs for the Lambda function invocation. This is present only if the invocation type is <code>RequestResponse</code> and the logs were requested. </p>', 'KMSAccessDeniedException$Type' => NULL, 'KMSAccessDeniedException$Message' => NULL, 'KMSDisabledException$Type' => NULL, 'KMSDisabledException$Message' => NULL, 'KMSInvalidStateException$Type' => NULL, 'KMSInvalidStateException$Message' => NULL, 'KMSNotFoundException$Type' => NULL, 'KMSNotFoundException$Message' => NULL, 'LayerVersionContentOutput$Location' => '<p>A link to the layer archive in Amazon S3 that is valid for 10 minutes.</p>', 'LayerVersionContentOutput$CodeSha256' => '<p>The SHA-256 hash of the layer archive.</p>', 'ListAliasesRequest$Marker' => '<p>Optional string. An opaque pagination token returned from a previous <code>ListAliases</code> operation. If present, indicates where to continue the listing.</p>', 'ListAliasesResponse$NextMarker' => '<p>A string, present if there are more aliases.</p>', 'ListEventSourceMappingsRequest$Marker' => '<p>A pagination token returned by a previous call.</p>', 'ListEventSourceMappingsResponse$NextMarker' => '<p>A pagination token that\'s returned when the response doesn\'t contain all event source mappings.</p>', 'ListFunctionsRequest$Marker' => '<p>Optional string. An opaque pagination token returned from a previous <code>ListFunctions</code> operation. If present, indicates where to continue the listing. </p>', 'ListFunctionsResponse$NextMarker' => '<p>A string, present if there are more functions.</p>', 'ListLayerVersionsRequest$Marker' => '<p>A pagination token returned by a previous call.</p>', 'ListLayerVersionsResponse$NextMarker' => '<p>A pagination token returned when the response doesn\'t contain all versions.</p>', 'ListLayersRequest$Marker' => '<p>A pagination token returned by a previous call.</p>', 'ListLayersResponse$NextMarker' => '<p>A pagination token returned when the response doesn\'t contain all layers.</p>', 'ListVersionsByFunctionRequest$Marker' => '<p> Optional string. An opaque pagination token returned from a previous <code>ListVersionsByFunction</code> operation. If present, indicates where to continue the listing. </p>', 'ListVersionsByFunctionResponse$NextMarker' => '<p>A string, present if there are more function versions.</p>', 'PolicyLengthExceededException$Type' => NULL, 'PolicyLengthExceededException$message' => NULL, 'PreconditionFailedException$Type' => '<p>The exception type.</p>', 'PreconditionFailedException$message' => '<p>The exception message.</p>', 'PublishVersionRequest$CodeSha256' => '<p>The SHA256 hash of the deployment package you want to publish. This provides validation on the code you are publishing. If you provide this parameter, the value must match the SHA256 of the $LATEST version for the publication to succeed. You can use the <b>DryRun</b> parameter of <a>UpdateFunctionCode</a> to verify the hash value that will be returned before publishing your new version.</p>', 'PublishVersionRequest$RevisionId' => '<p>An optional value you can use to ensure you are updating the latest update of the function version or alias. If the <code>RevisionID</code> you pass doesn\'t match the latest <code>RevisionId</code> of the function or alias, it will fail with an error message, advising you retrieve the latest function version or alias <code>RevisionID</code> using either <a>GetFunction</a> or <a>GetAlias</a>.</p>', 'RemoveLayerVersionPermissionRequest$RevisionId' => '<p>Only update the policy if the revision ID matches the ID specified. Use this option to avoid modifying a policy that has changed since you last read it.</p>', 'RemovePermissionRequest$RevisionId' => '<p>An optional value you can use to ensure you are updating the latest update of the function version or alias. If the <code>RevisionID</code> you pass doesn\'t match the latest <code>RevisionId</code> of the function or alias, it will fail with an error message, advising you to retrieve the latest function version or alias <code>RevisionID</code> using either <a>GetFunction</a> or <a>GetAlias</a>.</p>', 'RequestTooLargeException$Type' => NULL, 'RequestTooLargeException$message' => NULL, 'ResourceConflictException$Type' => '<p>The exception type.</p>', 'ResourceConflictException$message' => '<p>The exception message.</p>', 'ResourceInUseException$Type' => NULL, 'ResourceInUseException$Message' => NULL, 'ResourceNotFoundException$Type' => NULL, 'ResourceNotFoundException$Message' => NULL, 'ServiceException$Type' => NULL, 'ServiceException$Message' => NULL, 'SubnetIPAddressLimitReachedException$Type' => NULL, 'SubnetIPAddressLimitReachedException$Message' => NULL, 'TooManyRequestsException$retryAfterSeconds' => '<p>The number of seconds the caller should wait before retrying.</p>', 'TooManyRequestsException$Type' => NULL, 'TooManyRequestsException$message' => NULL, 'UnsupportedMediaTypeException$Type' => NULL, 'UnsupportedMediaTypeException$message' => NULL, 'UpdateAliasRequest$RevisionId' => '<p>An optional value you can use to ensure you are updating the latest update of the function version or alias. If the <code>RevisionID</code> you pass doesn\'t match the latest <code>RevisionId</code> of the function or alias, it will fail with an error message, advising you retrieve the latest function version or alias <code>RevisionID</code> using either <a>GetFunction</a> or <a>GetAlias</a>.</p>', 'UpdateEventSourceMappingRequest$UUID' => '<p>The identifier of the event source mapping.</p>', 'UpdateFunctionCodeRequest$RevisionId' => '<p>An optional value you can use to ensure you are updating the latest update of the function version or alias. If the <code>RevisionID</code> you pass doesn\'t match the latest <code>RevisionId</code> of the function or alias, it will fail with an error message, advising you to retrieve the latest function version or alias <code>RevisionID</code> using either using using either <a>GetFunction</a> or <a>GetAlias</a>.</p>', 'UpdateFunctionConfigurationRequest$RevisionId' => '<p>An optional value you can use to ensure you are updating the latest update of the function version or alias. If the <code>RevisionID</code> you pass doesn\'t match the latest <code>RevisionId</code> of the function or alias, it will fail with an error message, advising you to retrieve the latest function version or alias <code>RevisionID</code> using either <a>GetFunction</a> or <a>GetAlias</a>.</p>', ], ], 'SubnetIPAddressLimitReachedException' => [ 'base' => '<p>AWS Lambda was not able to set up VPC access for the Lambda function because one or more configured subnets has no available IP addresses.</p>', 'refs' => [], ], 'SubnetId' => [ 'base' => NULL, 'refs' => [ 'SubnetIds$member' => NULL, ], ], 'SubnetIds' => [ 'base' => NULL, 'refs' => [ 'VpcConfig$SubnetIds' => '<p>A list of VPC subnet IDs.</p>', 'VpcConfigResponse$SubnetIds' => '<p>A list of VPC subnet IDs.</p>', ], ], 'TagKey' => [ 'base' => NULL, 'refs' => [ 'TagKeyList$member' => NULL, 'Tags$key' => NULL, ], ], 'TagKeyList' => [ 'base' => NULL, 'refs' => [ 'UntagResourceRequest$TagKeys' => '<p>The list of tag keys to be deleted from the function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>.</p>', ], ], 'TagResourceRequest' => [ 'base' => NULL, 'refs' => [], ], 'TagValue' => [ 'base' => NULL, 'refs' => [ 'Tags$value' => NULL, ], ], 'Tags' => [ 'base' => NULL, 'refs' => [ 'CreateFunctionRequest$Tags' => '<p>The list of tags (key-value pairs) assigned to the new function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>.</p>', 'GetFunctionResponse$Tags' => '<p>Returns the list of tags associated with the function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>.</p>', 'ListTagsResponse$Tags' => '<p>The list of tags assigned to the function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>.</p>', 'TagResourceRequest$Tags' => '<p>The list of tags (key-value pairs) you are assigning to the Lambda function. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/tagging.html">Tagging Lambda Functions</a> in the <b>AWS Lambda Developer Guide</b>.</p>', ], ], 'ThrottleReason' => [ 'base' => NULL, 'refs' => [ 'TooManyRequestsException$Reason' => NULL, ], ], 'Timeout' => [ 'base' => NULL, 'refs' => [ 'CreateFunctionRequest$Timeout' => '<p>The amount of time that Lambda allows a function to run before terminating it. The default is 3 seconds. The maximum allowed value is 900 seconds.</p>', 'FunctionConfiguration$Timeout' => '<p>The amount of time that Lambda allows a function to run before terminating it.</p>', 'UpdateFunctionConfigurationRequest$Timeout' => '<p>The amount of time that Lambda allows a function to run before terminating it. The default is 3 seconds. The maximum allowed value is 900 seconds.</p>', ], ], 'Timestamp' => [ 'base' => NULL, 'refs' => [ 'FunctionConfiguration$LastModified' => '<p>The date and time that the function was last updated, in <a href="https://www.w3.org/TR/NOTE-datetime">ISO-8601 format</a> (YYYY-MM-DDThh:mm:ss.sTZD).</p>', 'GetLayerVersionResponse$CreatedDate' => '<p>The date that the layer version was created, in <a href="https://www.w3.org/TR/NOTE-datetime">ISO-8601 format</a> (YYYY-MM-DDThh:mm:ss.sTZD).</p>', 'LayerVersionsListItem$CreatedDate' => '<p>The date that the version was created, in ISO 8601 format. For example, <code>2018-11-27T15:10:45.123+0000</code>.</p>', 'PublishLayerVersionResponse$CreatedDate' => '<p>The date that the layer version was created, in <a href="https://www.w3.org/TR/NOTE-datetime">ISO-8601 format</a> (YYYY-MM-DDThh:mm:ss.sTZD).</p>', ], ], 'TooManyRequestsException' => [ 'base' => '<p>Request throughput limit exceeded</p>', 'refs' => [], ], 'TracingConfig' => [ 'base' => '<p>The function\'s AWS X-Ray tracing configuration.</p>', 'refs' => [ 'CreateFunctionRequest$TracingConfig' => '<p>Set <code>Mode</code> to <code>Active</code> to sample and trace a subset of incoming requests with AWS X-Ray.</p>', 'UpdateFunctionConfigurationRequest$TracingConfig' => '<p>Set <code>Mode</code> to <code>Active</code> to sample and trace a subset of incoming requests with AWS X-Ray.</p>', ], ], 'TracingConfigResponse' => [ 'base' => '<p>The function\'s AWS X-Ray tracing configuration.</p>', 'refs' => [ 'FunctionConfiguration$TracingConfig' => '<p>The function\'s AWS X-Ray tracing configuration.</p>', ], ], 'TracingMode' => [ 'base' => NULL, 'refs' => [ 'TracingConfig$Mode' => '<p>The tracing mode.</p>', 'TracingConfigResponse$Mode' => '<p>The tracing mode.</p>', ], ], 'UnreservedConcurrentExecutions' => [ 'base' => NULL, 'refs' => [ 'AccountLimit$UnreservedConcurrentExecutions' => '<p>The number of concurrent executions available to functions that do not have concurrency limits set. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/concurrent-executions.html">Managing Concurrency</a>.</p>', ], ], 'UnsupportedMediaTypeException' => [ 'base' => '<p>The content type of the <code>Invoke</code> request body is not JSON.</p>', 'refs' => [], ], 'UntagResourceRequest' => [ 'base' => NULL, 'refs' => [], ], 'UpdateAliasRequest' => [ 'base' => NULL, 'refs' => [], ], 'UpdateEventSourceMappingRequest' => [ 'base' => NULL, 'refs' => [], ], 'UpdateFunctionCodeRequest' => [ 'base' => NULL, 'refs' => [], ], 'UpdateFunctionConfigurationRequest' => [ 'base' => NULL, 'refs' => [], ], 'Version' => [ 'base' => NULL, 'refs' => [ 'AliasConfiguration$FunctionVersion' => '<p>Function version to which the alias points.</p>', 'CreateAliasRequest$FunctionVersion' => '<p>Lambda function version for which you are creating the alias.</p>', 'FunctionConfiguration$Version' => '<p>The version of the Lambda function.</p>', 'InvocationResponse$ExecutedVersion' => '<p>The function version that has been executed. This value is returned only if the invocation type is <code>RequestResponse</code>. For more information, see <a href="http://docs.aws.amazon.com/lambda/latest/dg/lambda-traffic-shifting-using-aliases.html">Traffic Shifting Using Aliases</a>.</p>', 'ListAliasesRequest$FunctionVersion' => '<p>If you specify this optional parameter, the API returns only the aliases that are pointing to the specific Lambda function version, otherwise the API returns all of the aliases created for the Lambda function.</p>', 'UpdateAliasRequest$FunctionVersion' => '<p>Using this parameter you can change the Lambda function version to which the alias points.</p>', ], ], 'VpcConfig' => [ 'base' => '<p>The VPC security groups and subnets attached to a Lambda function.</p>', 'refs' => [ 'CreateFunctionRequest$VpcConfig' => '<p>If your Lambda function accesses resources in a VPC, you provide this parameter identifying the list of security group IDs and subnet IDs. These must belong to the same VPC. You must provide at least one security group and one subnet ID.</p>', 'UpdateFunctionConfigurationRequest$VpcConfig' => '<p>Specify security groups and subnets in a VPC to which your Lambda function needs access.</p>', ], ], 'VpcConfigResponse' => [ 'base' => '<p>The VPC security groups and subnets attached to a Lambda function.</p>', 'refs' => [ 'FunctionConfiguration$VpcConfig' => '<p>The function\'s networking configuration.</p>', ], ], 'VpcId' => [ 'base' => NULL, 'refs' => [ 'VpcConfigResponse$VpcId' => '<p>The ID of the VPC.</p>', ], ], 'Weight' => [ 'base' => NULL, 'refs' => [ 'AdditionalVersionWeights$value' => NULL, ], ], ],];
